%define anolis_release 2
%global _hardened_build 1
%global __provides_exclude_from ^(%{python3_sitearch}/.*\\.so)$

Name:     iscsi-initiator-utils
Version:  2.1.8
Release:  %{anolis_release}%{?dist}
Summary:  iSCSI daemon and utility programs
License:  GPLv2+
URL:      https://github.com/open-iscsi/open-iscsi
Source0:  https://github.com/open-iscsi/open-iscsi/archive/refs/tags/%{version}.tar.gz
Source1:  04-iscsi
Source2:  iscsi-tmpfiles.conf

Patch0001: 0001-unit-file-tweaks.patch
Patch0002: 0002-idmb_rec_write-check-for-tpgt-first.patch
Patch0003: 0003-idbm_rec_write-seperate-old-and-new-style-writes.patch
Patch0004: 0004-idbw_rec_write-pick-tpgt-from-existing-record.patch
Patch0005: 0005-update-initscripts-and-docs.patch
Patch0006: 0006-use-var-for-config.patch
Patch0007: 0007-libiscsi.patch
Patch0008: 0008-libiscsi-introduce-sessions-API.patch
Patch0009: 0009-remove-the-offload-boot-supported-ifdef.patch
Patch0010: 0010-Revert-iscsiadm-return-error-when-login-fails.patch
Patch0011: 0011-use-var-lib-iscsi-in-libopeniscsiusr.patch
Patch0012: 0012-Coverity-scan-fixes.patch
Patch0013: 0013-iscsi_if.h-replace-zero-length-array-with-flexible-a.patch
Patch0014: 0014-minor-service-file-updates.patch
Patch0015: 0015-try-not-to-require-network-online.patch
Patch0016: 0016-add-some-service-in-system.patch

Patch1001: 1001-add-ISCSI_VERSION_STR-define.patch
Patch1002: 1002-fix-the-libiscsi-build-error.patch
Patch1003: 1003-change-the-sbin-dir-to-usr-sbin.patch

BuildRequires: autoconf automake
BuildRequires: flex bison doxygen kmod-devel libtool systemd-units
BuildRequires: isns-utils-devel systemd-devel libmount-devel openssl-devel

Requires: %{name}-iscsiuio >= %{EVR}

Conflicts: NetworkManager < 1.20

%description
The iscsi package provides the server daemon for the iSCSI protocol,
as well as the utility programs used to manage it. iSCSI is a protocol
for distributed disk access using SCSI commands sent over Internet
Protocol networks.

%package iscsiuio
Summary: Userspace configuration daemon required for some iSCSI hardware
License: BSD
Requires: %{name} = %{EVR}

%description iscsiuio
The iscsiuio configuration daemon provides network configuration help
for some iSCSI offload hardware.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{EVR}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package -n python3-%{name}
Summary: Python %{python3_version} bindings to %{name}
Requires: %{name} = %{EVR}
BuildRequires: python3-devel python3-setuptools

%description -n python3-%{name}
The %{name}-python3 package contains Python %{python3_version} bindings to the
libiscsi interface for interacting with %{name}

%prep
%autosetup -n open-iscsi-%{version} -p1
%{__sed} -i -e 's|^exec_prefix = /$|exec_prefix = %{_exec_prefix}|' Makefile

%build
# avoid undefined references linking failures
%undefine _ld_as_needed

cd iscsiuio
autoreconf --install
%{configure}
cd -
make OPTFLAGS="%{optflags} %{?__global_ldflags}"

cd libiscsi
%py3_build
touch -r libiscsi.doxy html/*
cd -

%install
make DESTDIR=%{?buildroot} LIB_DIR=%{_libdir} \
          install_programs \
          install_doc \
          install_etc \
          install_libopeniscsiusr

rm %{buildroot}%{_mandir}/man8/iscsi_discovery.8
rm %{buildroot}%{_mandir}/man8/iscsi_fw_login.8
install -pm 755 usr/iscsistart %{buildroot}%{_sbindir}
install -pm 755 iscsiuio/src/unix/iscsiuio %{buildroot}%{_sbindir}
install -pm 644 doc/iscsistart.8 %{buildroot}%{_mandir}/man8
install -pm 644 doc/iscsi-iname.8 %{buildroot}%{_mandir}/man8
install -pm 644 iscsiuio/docs/iscsiuio.8 %{buildroot}%{_mandir}/man8
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -pm 644 iscsiuio/iscsiuiolog %{buildroot}%{_sysconfdir}/logrotate.d

install -d %{buildroot}%{_sharedstatedir}/iscsi
install -d %{buildroot}%{_sharedstatedir}/iscsi/nodes
install -d %{buildroot}%{_sharedstatedir}/iscsi/send_targets
install -d %{buildroot}%{_sharedstatedir}/iscsi/static
install -d %{buildroot}%{_sharedstatedir}/iscsi/isns
install -d %{buildroot}%{_sharedstatedir}/iscsi/slp
install -d %{buildroot}%{_sharedstatedir}/iscsi/ifaces
install -d %{buildroot}%{_rundir}/lock/iscsi
touch %{buildroot}%{_rundir}/lock/iscsi/lock

install -d %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi-starter.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi-init.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi-onboot.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi-shutdown.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsid.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsid.socket %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsiuio.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsiuio.socket %{buildroot}%{_unitdir}

install -d %{buildroot}%{_libexecdir}
install -pm 755 etc/systemd/iscsi-mark-root-nodes %{buildroot}%{_libexecdir}

install -d %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d
install -pm 755 %{SOURCE1} %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d

install -d %{buildroot}%{_tmpfilesdir}
install -pm 644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/iscsi.conf

install -d %{buildroot}%{_libdir}
install -pm 755 libiscsi/libiscsi.so.0 %{buildroot}%{_libdir}
ln -s libiscsi.so.0 %{buildroot}%{_libdir}/libiscsi.so
install -d %{buildroot}%{_includedir}
install -pm 644 libiscsi/libiscsi.h %{buildroot}%{_includedir}

mkdir -p %{buildroot}/%{_udevrulesdir}
mv %{buildroot}/%{_sysconfdir}/udev/rules.d/50-iscsi-firmware-login.rules %{buildroot}/%{_udevrulesdir}/50-iscsi-firmware-login.rules
rm -rf %{buildroot}/%{_sysconfdir}/udev

install -d %{buildroot}%{python3_sitearch}
pushd libiscsi
%py3_install
popd

%generate_compatibility_deps

%post
%systemd_post iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%preun
%systemd_preun iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%postun
%systemd_postun iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%post iscsiuio
%systemd_post iscsiuio.service iscsiuio.socket

%preun iscsiuio
%systemd_preun iscsiuio.service iscsiuio.socket

%postun iscsiuio
%systemd_postun iscsiuio.service iscsiuio.socket

%triggerun -- iscsi-initiator-utils < 2.1.4
systemctl --no-reload preset iscsi.service iscsi-starter.service &>/dev/null || :

%files
%dir %{_sysconfdir}/iscsi
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/iscsi/iscsid.conf
%dir %{_sharedstatedir}/iscsi
%dir %{_sharedstatedir}/iscsi/nodes
%dir %{_sharedstatedir}/iscsi/isns
%dir %{_sharedstatedir}/iscsi/static
%dir %{_sharedstatedir}/iscsi/slp
%dir %{_sharedstatedir}/iscsi/ifaces
%dir %{_sharedstatedir}/iscsi/send_targets
%ghost %attr(0700, root, root) %{_rundir}/lock/iscsi
%ghost %attr(0600, root, root) %{_rundir}/lock/iscsi/lock
%{_unitdir}/iscsi.service
%{_unitdir}/iscsi-starter.service
%{_unitdir}/iscsi-onboot.service
%{_unitdir}/iscsi-init.service
%{_unitdir}/iscsi-shutdown.service
%{_unitdir}/iscsid.service
%{_unitdir}/iscsid.socket
%{_libexecdir}/iscsi-mark-root-nodes
%{_prefix}/lib/NetworkManager
%{_tmpfilesdir}/iscsi.conf
%{_sbindir}/iscsi-iname
%{_sbindir}/iscsiadm
%{_sbindir}/iscsid
%{_sbindir}/iscsistart
%{_sbindir}/iscsi-gen-initiatorname
%{_sbindir}/iscsi_discovery
%{_sbindir}/iscsi_fw_login
%{_sbindir}/iscsi_offload
%{_libdir}/libiscsi.so.0
%{_libdir}/libopeniscsiusr.so.*

%dir %{abidir}
%{abidir}/iscsi-iname-option.list
%{abidir}/iscsiadm-option.list
%{abidir}/iscsid-option.list
%{abidir}/iscsistart-option.list
%{abidir}/iscsi-gen-initiatorname-option.list
%{abidir}/libopeniscsiusr.dump
%{abidir}/libiscsi.dump

%{_mandir}/man3/*.zst
%{_mandir}/man8/iscsi-iname.8*.zst
%{_mandir}/man8/iscsiadm.8*.zst
%{_mandir}/man8/iscsid.8*.zst
%{_mandir}/man8/iscsistart.8*.zst
%{_mandir}/man8/iscsi-gen-initiatorname.8*.zst
%{_udevrulesdir}/50-iscsi-firmware-login.rules
%doc README

%files iscsiuio
%config(noreplace) %{_sysconfdir}/logrotate.d/iscsiuiolog
%{_sbindir}/iscsiuio
%{_unitdir}/iscsiuio.service
%{_unitdir}/iscsiuio.socket
%{abidir}/iscsiuio-option.list
%{_mandir}/man8/iscsiuio.8*.zst

%files devel
%doc libiscsi/html
%{_libdir}/libiscsi.so
%{_includedir}/libiscsi.h
%{_libdir}/libopeniscsiusr.so
%{_includedir}/libopeniscsiusr.h
%{_includedir}/libopeniscsiusr_common.h
%{_includedir}/libopeniscsiusr_iface.h
%{_includedir}/libopeniscsiusr_node.h
%{_includedir}/libopeniscsiusr_session.h
%{_libdir}/pkgconfig/libopeniscsiusr.pc

%files -n python3-%{name}
%{python3_sitearch}/*
%{abidir}/libiscsi.cpython-310-%{_arch}-linux-gnu.dump

%changelog
* Mon Apr 10 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 2.1.8-2
- Refactor the specfile

* Tue Mar 07 2023 happy_orange <songnannan@linux.alibaba.com> - 2.1.8-1
- update to 2.1.8

* Thu Dec 01 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.1.6-3
- fix iscsi-init.service start failed

* Thu Nov 03 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.1.6-2
- optimise spec file

* Wed Apr 20 2022 yuanhui <yuanhui@linux.alibaba.com> - 2.1.6-1
- Init iscsi-initiator-utils for anolis os 23
